"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ChiSquare1KGenomesPhase3Pop(ProtocolElement):
    """
    Chi-square test for goodness of fit of this sample to 1000 Genomes
    Phase 3 populations
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "chiSquare",
        "kGSuperPopCategory",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "kGPopCategory": reports_3_0_0.KGPopCategory,
            "kGSuperPopCategory": reports_3_0_0.KGSuperPopCategory,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.KGPopCategory": reports_3_0_0.KGPopCategory,
            "org.gel.models.report.avro.KGSuperPopCategory": reports_3_0_0.KGSuperPopCategory,
            "org.gel.models.report.avro.ChiSquare1KGenomesPhase3Pop": reports_3_0_0.ChiSquare1KGenomesPhase3Pop,
        }

    __slots__ = [
        "chiSquare",
        "kGSuperPopCategory",
        "kGPopCategory",
    ]

    def __init__(
        self,
        chiSquare,
        kGSuperPopCategory,
        kGPopCategory=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.ChiSquare1KGenomesPhase3Pop model.

        :param chiSquare:
            Chi-square test for goodness of fit of this sample to this 1000
            Genomes Phase 3 population
        :type chiSquare: float
        :param kGSuperPopCategory:
            1K Super Population
        :type kGSuperPopCategory: KGSuperPopCategory
        :param kGPopCategory:
            1K Population
        :type kGPopCategory: None | KGPopCategory
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
